package org.yaoqiang.collaboration.dialog;

import java.awt.Container;

import org.yaoqiang.collaboration.MainPanel;
import org.yaoqiang.dialog.Panel;
import org.yaoqiang.dialog.PanelContainer;

/**
 * CollaborationPanel
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class CollaborationPanel extends Panel {

	private static final long serialVersionUID = -5566859541054413856L;

	public CollaborationPanel(PanelContainer pc, Object owner) {
		super(pc, owner);
	}

	public CollaborationDialog getDialog() {
		for (Container p = getPanelContainer().getParent(); p != null; p = p.getParent()) {
			if (p instanceof CollaborationDialog) {
				return (CollaborationDialog) p;
			}
		}
		return null;
	}

	public MainPanel getMainPanel() {
		if (getDialog() != null) {
			return getDialog().getMainPanel();
		}
		return null;
	}

	public CollaborationPanel getParentPanel() {
		if (getDialog() != null) {
			return getDialog().getParentPanel();
		}
		return null;
	}

}
